#include "fxlib.h"
#include "math.h"
#include "stdlib.h"
#include "string.h"
#include "stdio.h"
#include "memory.h"
#include "usefull.h"
#include "MonochromeLib.h"
#include "input.h"
#include "Infos.h"

void read(int *Best, int *Money, unsigned char *Boats)	//Fonction de lecture de fichier de sauvegarde
{
	int handle;
	handle = memory_openfile(FILEPATH,_OPENMODE_READ);
	memory_readfile(handle,(void *)Best,4,-1);
	memory_readfile(handle,(void *)Money,4,-1);
	memory_readfile(handle,(void *)Boats,3,-1);
	memory_closefile(handle);
}

void save(int Best, int Money, unsigned char *Boats)	//Fonction de création de fichier de sauvegarde
{
	int handle;
	memory_deletefile(FILEPATH);
	memory_createfile(FILEPATH,11);
	handle = memory_openfile(FILEPATH,_OPENMODE_WRITE);
	memory_writefile(handle,(void *)(&Best),4);
	memory_writefile(handle,(void *)(&Money),4);
	memory_writefile(handle,(void *)Boats,3);
	memory_closefile(handle);
}

void selection(int Menu, int *Selection, Type_Action_Selection *Action_Selection)
{
	static unsigned int Selection_Wait = 0;	//Variable qui va "bloquer" le déplacement du curseur pour faire des déplacements de ce dernier au coup par coup

	const unsigned char Horizontal_Menu[] = {2, 2, 2, 1, 2};
	const unsigned char Vertical_Menu[] = {1, 2, 1, 2, 1};
	const Type_Action_Selection Grid_Menu[5][2][2] = {
		{{PLAY, EXIT}},
		{{RUSH, BUY_MENU_1}, {MENU_0, SELL_MENU_1}},
		{{MENU_1, BUY_MENU_2}},
		{{YES}, {NO}},
		{{MENU_1, SELL_MENU_2}}};

	int X_Selection = *Selection%Horizontal_Menu[Menu];
	int Y_Selection = *Selection/Horizontal_Menu[Menu];

	int Direction_Curseur = input_dir4();

	if(!Selection_Wait && Direction_Curseur)
	{
		switch (Direction_Curseur)
		{
			case 6 : X_Selection = (X_Selection+1)%Horizontal_Menu[Menu]; break;
			case 4 : X_Selection = (X_Selection-1+Horizontal_Menu[Menu])%Horizontal_Menu[Menu]; break;
			case 2 : Y_Selection = (Y_Selection+1)%Vertical_Menu[Menu]; break;
			case 8 : Y_Selection = (Y_Selection-1+Vertical_Menu[Menu])%Vertical_Menu[Menu]; break;
		}

		*Selection = Y_Selection*Horizontal_Menu[Menu]+X_Selection;
		Selection_Wait = FPS/8;
	}

	if(input_press(31))
	{
		*Action_Selection = Grid_Menu[Menu][Y_Selection][X_Selection];
		while(key_down(31));
	}

	if(input_dir4() && Selection_Wait)Selection_Wait--;	//Si on laisse une touche fléchée enfoncée on décrémente la variable de blockage
	else if(!input_dir4())Selection_Wait = 0;			//Si il relache _________________ on réinitialise directement la variable de blockage à 0
}

int reef_value(int *Reefs_Grid, int X_Grid, int Y_Grid)
{
	if(X_Grid >= 0 && X_Grid <= WIDTH_GRID_REEFS && Y_Grid >= 0 && Y_Grid <= HEIGHT_GRID_REEFS)return Reefs_Grid[X_Grid+WIDTH_GRID_REEFS*Y_Grid];
	else return 0;
}

void nop(Type_Nop Nop)
{
	draw_nop(Nop);
	ML_display_vram();

	while(!key_down(31));
	while(key_down(31));
}