#include "fxlib.h"
#include "math.h"
#include "stdlib.h"
#include "string.h"
#include "stdio.h"
#include "memory.h"
#include "usefull.h"
#include "MonochromeLib.h"
#include "input.h"
#include "Infos.h"

static int SysCallCode[] = {0xD201422B,0x60F20000,0x80010070};				//Truc pour pouvoir utiliser le temps
static int (*SysCall)(int R4, int R5, int R6, int R7, int FNo ) = (void*)&SysCallCode;

int AddIn_main(int isAppli, unsigned short OptionNum)
{
	int i;

	int Selection = 0;
	Type_Action_Selection Action_Selection = NOT_ACTION;

	int Best = 0;
	int Money = 0;
	unsigned char Boats[3] = {1, 0, 0};

	int Menu = 0;

	unsigned char Buy_Boat = 0;
	const unsigned short Price_Boat[] = {100, 250, 425, 600};

	int Number_Boats, Sell_Boat, Gap;

	if(!memory_exists(FILEPATH)){
		memory_createfile(FILEPATH,11);
		save(Best, Money, Boats);
		}

	read(&Best, &Money, Boats);

	srand(time_getTicks());	//Initialisation de l'aleatoire

	while(key_down(31));

	while(Action_Selection != EXIT)
	{
		ML_clear_vram();
		input_update();

		if(Action_Selection != NOT_ACTION)
		{
			Action_Selection = NOT_ACTION;
			Selection = 0;
		}

		selection(Menu, &Selection, &Action_Selection);

		draw_menu(Menu, Selection, Best, Money, Boats, Buy_Boat, Sell_Boat);

		setFps(128/FPS);

		ML_display_vram();

		if(Action_Selection == MENU_0)Menu = 0;

		if(Action_Selection == PLAY || Action_Selection == MENU_1)
		{
			Menu = 1;
			Number_Boats = 0;
			for(i = 0; i < 3; i++)if(Boats[i])Number_Boats++;
		}

		if(Action_Selection == BUY_MENU_1)Menu = 2;

		if(Action_Selection == RUSH)
		{
			for(i = 0; i < 2; i++)if(!Boats[i])
			{
				Boats[i] = Boats[i+1];
				Boats[i+1] = 0;
			}
			game(&Best, &Money, Boats);
			save(Best, Money, Boats);
			Number_Boats = 0;
			for(i = 0; i < 3; i++)if(Boats[i])Number_Boats++;
		}

		if(Action_Selection == BUY_MENU_2)
		{
			if(Number_Boats == 3)nop(FULL_FLEET);
			else if(Money < Price_Boat[Buy_Boat])nop(MORE_MONEY);
			else
			{
				for(i = 0; i < 3; i++)if(!Boats[i])break;
				Boats[i] = Buy_Boat+1;
				Money -= Price_Boat[Buy_Boat];
				Number_Boats++;
				save(Best, Money, Boats);
			}
		}
		if(Menu == 2)
		{
			if(input_trigger(79))Buy_Boat = (Buy_Boat+3)%4;
			if(input_trigger(29))Buy_Boat = (Buy_Boat+1)%4;
		}

		if(Action_Selection == SELL_MENU_1)
		{
			Menu = 4;
			Sell_Boat = 0;
			Gap = 1;
		}
		if(Action_Selection == SELL_MENU_2)
		{
			if(Number_Boats == 1)nop(SELL_LAST);
			else
			{
				Money = (Money+Price_Boat[Boats[Sell_Boat]-1]/2 < 999999) ? Money+Price_Boat[Boats[Sell_Boat]-1]/2 : 999999;
				Boats[Sell_Boat] = 0;
				Gap = 1;
				Number_Boats--;
			}
		}
		if(Menu == 4)
		{
			if(input_trigger(28))Gap = 2;
			if(input_trigger(37))Gap = 1;
			do { Sell_Boat = (Sell_Boat+Gap)%3; } while(!Boats[Sell_Boat]);
			Gap = 0;
		}
	}
	return 1;
}

/*****************************************************************************************/
//Trucs de l'Add-In, NE PAS TOUCHER !

#pragma section _BR_Size
unsigned long BR_Size;
#pragma section

#pragma section _TOP

int InitializeSystem(int isAppli, unsigned short OptionNum)
{
    return INIT_ADDIN_APPLICATION(isAppli, OptionNum);
}

#pragma section
